#pragma once

#include <iostream>
#include <string>

using std::cout;
using std::cin;
using std::endl;
using std::string;

// Employee is a base class
class Employee
{
	// We will not use qualifiers (i.e. like const) in all possible places
	// in this example to simplify a bit
public:
	Employee(const string& newName = "", const double& newPayRate = 15.25, 
		const double& newHours = 0.0);
	~Employee();

	string getName();
	double getPayRate();
	double getHours();

	void setName(const string& newName);
	void setPayRate(const double& newPayRate);
	void setHours(const double& newHours);

	virtual double calculatePay(); // it's possibe to override this function in a derived class

//private:
protected: // allows for the derived class to acquire and directly access the protected members,
	       // unlike with private members; which remain hidden from the derived class
	string mName;
	double mPayRate;
	double mHours;
};